#ifndef UMESH2DGUI_H
#define UMESH2DGUI_H

/* 

    umesh2dgui, a GUI for umesh2d grid generator 

    Copyright (C) 2003 Gabriele Dini Ciacci
    Copyright (C) 2004 Gabriele Dini Ciacci
    Copyright (C) 2005 Gabriele Dini Ciacci
  
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <fltk/Window.h>
#include <fltk/Widget.h>
#include <fltk/run.h>
#include <fltk/Choice.h>
#include <fltk/Color.h>
#include <fltk/Input.h>
#include <fltk/Group.h>
#include <fltk/ValueInput.h>
#include <fltk/Button.h>
#include <fltk/file_chooser.h>
#include <fltk/ask.h> // this is for message, ask, alert...
#include <fltk/ScrollGroup.h>
#include <fltk/MenuBar.h>
#include <fltk/Item.h>
#include <fltk/ItemGroup.h>
#include <fltk/TabGroup.h>
#include <fltk/Box.h>

#include <stdio.h>

#include "u2d_core.h"


void line_cb();
void circle_cb();
void ellipse_cb();
void data_cb();
void new_dataline_cb();
void clear_cb();
void add_line_cb();
void add_circle_cb();
void add_ellipse_cb();
void add_data_cb();
void add_generic(Primitive *prim);
void openfilebrowser();
void createfile_cb();
void about_cb();
void glview_cb();
void browserview_cb();
void openitem_cb();
void saveasitem_cb();
void saveitem_cb();
void quititem_cb();
void browser_del_prim_cb();
void main_core_cb();
void boundary_nextbutton_cb();
void domain_nextbutton_cb();
void domain_prevbutton_cb();
void creation_prevbutton_cb();
void umesh2d_format_cb();
void umesh2d_fe_format_cb();
void umesh2d_fv_format_cb();
void msgout(char *format, ...);
void new_steiner_cb();
void new_backgrid_cb();
void steiner_del_cb(fltk::Widget *button, void *);
void backgrid_del_cb(fltk::Widget *button, void*);
void debug_cb();

/*
class Umesh2DGUI {


}
*/


class Coordinates : public fltk::Group {
  fltk::ValueInput xcoord;
  fltk::ValueInput ycoord;
 private:

 public:
  Coordinates(int x, int y, int w, int h, const char *label);
  ~Coordinates();

  /*
  double getx(){
    return this->xcoord.value();
  }
  double gety(){
    return this->xcoord.value();
  }
  */

};


Coordinates::Coordinates(int x, int y, int w, int h, const char *label) :
  fltk::Group(x, y, w, h, label),
  // xcoord(x, y, w, h, "x:"),
  //  ycoord(x, y, w, h, "y:") {
  xcoord(x + w/2, y + 2, w/2 - 1, (h - 4)/2, "x:"),
  ycoord(x + w/2, y + h - 2 - (h - 4)/2, w/2 - 1, (h - 4)/2, "y:") {
  
  this->box(fltk::BORDER_FRAME);
  this->align(fltk::ALIGN_INSIDE_LEFT);
  //  xcoord.range(-1000, 1000);
  //  xcoord.step(0.01);
  //  xcoord.linesize(0.01);

  //  ycoord.range(-1000, 1000);
  //  ycoord.step(0.01);
  //  ycoord.linesize(0.01);

  end(); // ends the fltk::Group that automatically starts when instanced.
}

Coordinates::~Coordinates() {


}





#endif
